#include <stdio.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>

int main(void) {
  int n, c;
  fd_set fds;
  struct timeval timeout;
  int fd;
  
  fd = 0;              /* stdin */
  FD_ZERO(&fds);       /* zera a lista de descritores */
  FD_SET(fd, &fds);    /* adiciona descritor (stdin) aa lista */
  timeout.tv_sec = 5;  /* 5 segundos */
  timeout.tv_usec = 0; /* 0 microsegundos */

  /* leia o teclado, aguardando no maximo 5 segundos */
  n = select(1, &fds, (fd_set *)0, (fd_set *)0, &timeout);
  if(n > 0 && FD_ISSET(fd, &fds))   /* FD_ISSET testa se descritor especifico esta pronto */
    {
      c = getchar();  /* nao ira bloquear */
      printf("Caractere %c teclado.\n", c);
    }
  else if(n == 0)    /* timeout */
        {
        printf("Nada foi teclado em 5s.\n");
        }
       else perror("select()");

  exit(1);
  }
